<!DOCTYPE html>
<html lang="en">

<head>
	<title>photoCRUD</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

	<link rel="stylesheet" href="mystyle.css">
	<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị photo</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label>Album</label>
				</div>
				<div class="col-sm-9">
					<select id="album-select" class="form-control">
						<option value="NONE_SELECTED">Chọn Album</option>
					</select>
				</div>
			</div>

		</div>
		<!-- Create voucher modal -->
		<div>
			<div id="create-photo-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Create new Photo</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Mã Photo</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-photo-code" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Tên Photo</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-photo-name" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Photo Link</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-photo-link" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Mô tả</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-photo-description" name="note"
											class="form-control">
									</div>
								</div>

							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-create-photo">Create Album</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Update voucher modal -->
		<div>
			<div id="update-photo-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Update Album</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Mã Photo</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-photo-code-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Tên Photo</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-photo-name-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Link Photo</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-photo-link-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Mô tả</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-photo-description-update" name="note"
											class="form-control">
									</div>
								</div>

							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-update-photo">Update Album</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Delete confirm modal -->
		<div>
			<div class="modal fade" tabindex="-1" id="delete-modal">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Photo Delete Confirmation</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<label>Bạn có chắc chắn muốn xóa photo này không?</label>
						</div>
						<div class="modal-footer">
							<button class="btn btn-danger" id="btn-confirm-delete-photo">Confirm</button>
							<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<button class="btn btn-success " id="create-album">Add Photo</button>
		<table class="table table-bordered table-striped table-hover" id="photo-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>Mã photo</th>
					<th>Tên photo</th>
					<th>Link Photo</th>
					<th>Mô tả</th>
					<th>Ngày tạo</th>
					<th>Action</th>
				</tr>
		</table>
	</div>
	<script>
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		// Biến mảng hằng số chứa danh sách tên các thuộc tính
		const gPHOTO_COLS = ["id", "photoCode", "photoName", "photoLink", "photoDescription", "created", "action"];

		// Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
		const gPHOTO_STT_COL = 0;
		const gPHOTO_CODE_COL = 1;
		const gPHOTO_NAME_COL = 2;
		const gPHOTO_LINK_COL = 3;
		const gPHOTO_DESCRIPTION_COL = 4;
		const gPHOTO_CREATED_COL = 5;
		const gPHOTO_ACTION_COL = 6;
		var table = $("#photo-table").DataTable({
			columns: [
				{ data: gPHOTO_COLS[gPHOTO_STT_COL] },
				{ data: gPHOTO_COLS[gPHOTO_CODE_COL] },
				{ data: gPHOTO_COLS[gPHOTO_NAME_COL] },
				{ data: gPHOTO_COLS[gPHOTO_LINK_COL] },
				{ data: gPHOTO_COLS[gPHOTO_DESCRIPTION_COL] },
				{ data: gPHOTO_COLS[gPHOTO_CREATED_COL] },
				{ data: gPHOTO_COLS[gPHOTO_ACTION_COL] }
			],
			columnDefs: [
				{ // định nghĩa lại cột action
					targets: gPHOTO_ACTION_COL,
					defaultContent: `
					<i class="fas fa-edit edit-photo"></i>
					<i class="fas fa-trash-alt delete-photo"></i>
			  		`
				}
			]
		})
		$(document).ready(function () {
			callApiToGetAlbum();
			//create new photo
			$('#create-album').on('click', function () {
				onBtnAddPhotoClick();
			})
			$('#btn-create-photo').on('click', function () {

				onBtnCreatePhotoOnModalClick();
			})
			//edit photo
			$('#photo-table').on('click', '.edit-photo', function () {


				onBtnEditAlbumClick(this);
			})
			$('#btn-update-photo').on('click', function () {

				onBtnUpdateOnModalClick()
			})

			//xóa photo
			$('#photo-table').on('click', '.delete-photo', function () {

				onBtnDeleteAlbumClick(this);
			})
			$('#btn-confirm-delete-photo').on('click', function () {

				onBtnConfirmOnDeleteModalClick(this);
			})

		})

		var gRowSelected = ''
		var gAlbumList = '';
		var galbumIdSelected = '';
		var glistPhoto = [];
		var gRowPhotoSelected = '';
		var gphotoIdSelected = ''

		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */


		//hàm thực hiện khi nhấn nút add new photo
		function onBtnAddPhotoClick() {
			$("#create-photo-modal").modal("show");

		}

		//hàm thực hiện khi lúc nút edit
		function onBtnEditAlbumClick(paramButton) {
			$("#update-photo-modal").modal("show");
			gphotoIdSelected = getPhotoIdFromButton(paramButton)

			console.log('check id photo selected', gphotoIdSelected)
			callApiToGetPhotoById(gphotoIdSelected)
		}
		//hàm thực hiện khi nhấn nút update trên modal
		function onBtnUpdateOnModalClick() {
			updatePhoto(gphotoIdSelected);
			$("#update-photo-modal").modal("hide");


		}

		//Hàm thực hiện khi nhấn nút delete
		function onBtnDeleteAlbumClick(paramButton) {
			$("#delete-modal").modal("show");
			gphotoIdSelected = getPhotoIdFromButton(paramButton)

		}
		//hàm thực hiện khi nhấn nút confirm trên delete modal
		function onBtnConfirmOnDeleteModalClick() {
			deletedPhoto();
			$("#delete-modal").modal("hide");

		}


		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		/*** DELETE-------------------------------------------------------------------------- */
		function deletedPhoto() {
			callApiToDeleteData(gphotoIdSelected);
			onPageLoading();
		}
		function callApiToDeleteData(id) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/photo/delete/${id}`,
				type: 'DELETE',
				async: false,
				// contentType: "application/json;charset=UTF-8",
				// data: JSON.stringify(paramOrderObject),
				success: function (res) {
					alert('Delete success')

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}
		/*** UPDATE-------------------------------------------------------------------------- */


		function updatePhoto(paramPhotoId) {
			let objData = {
				photoCode: '',
				photoName: '',
				photoLink: '',
				photoDescription: '',
			}

			let objDataFromForm = getDataOnFormUpdate(objData);
			console.log("check UPDATE", objDataFromForm)
			var vCheck = validateDataOnform(objDataFromForm);
			if (vCheck) {
				let photoExist = '';
				if (glistPhoto && glistPhoto.length > 0) {

					for (let i = 0; i < glistPhoto.length; i++) {
						if (glistPhoto[i].photoCode == objDataFromForm.photoCode) {
							alert("photo existed");
							photoExist = glistPhoto[i];
							console.log('Album existed', photoExist)
						}
					}

				}
				if (photoExist == '') {
					callApiToUpdateData(paramPhotoId, objDataFromForm);
					onPageLoading();
				}



			}
		}

		//hàm thu thập dư liệu trên form update
		function getDataOnFormUpdate(obj) {
			obj.photoCode = $('#input-photo-code-update').val();
			obj.photoName = $('#input-photo-name-update').val();
			obj.photoLink = $('#input-photo-link-update').val();
			obj.photoDescription = $('#input-photo-description-update').val();
			return obj
		}
		//hàm gọi api để update album
		function callApiToUpdateData(id, paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/photo/update/${id}`,
				type: 'PUT',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {
					console.log('check data update photo response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}


		//hàm trả ra id photo khi nhấn nút edit
		function getPhotoIdFromButton(paramButton) {
			var vTableRow = $(paramButton).parents("tr");
			gRowPhotoSelected = table.row(vTableRow).data();
			console.log(gRowPhotoSelected.id);
			return gRowPhotoSelected.id;
		}
		//hàm gọi api để lấy photo cần edit theo id
		function callApiToGetPhotoById(id) {

			$.ajax({
				url: `http://localhost:8080/photos/detail/${id}`,
				async: false,
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log('check data photo need to update ress', res);
					// if (glistAlbum && glistAlbum.length > 0) {
					// 	glistAlbum.map((item, index) => {
					// 		if (item.id == res.id) {
					// 			glistAlbum.splice(index, 1)
					// 		}
					// 	})
					// }
					showDataUpdateOnForm(res);
				},
				error: function (err) {
					console.log(err.response);
				}
			})

		}
		//hàm hiển thị data lên form edit
		function showDataUpdateOnForm(paramPhoto) {
			$('#input-photo-code-update').val(paramPhoto.photoCode);
			$('#input-photo-name-update').val(paramPhoto.photoName);
			$('#input-photo-link-update').val(paramPhoto.photoLink);
			$('#input-photo-description-update').val(paramPhoto.photoDescription);

		}

		/*** CREATE-------------------------------------------------------------------------- */
		//hàm thực hiện khi nhấn create photo trên modal
		function onBtnCreatePhotoOnModalClick() {
			createNewPhoto();
			$("#create-album-modal").modal("hide");
		}
		//save new photo
		function createNewPhoto() {
			let objData = {
				photoCode: '',
				photoName: '',
				photoLink: '',
				photoDescription: '',
			}
			let objDataFromForm = getDataOnForm(objData);
			console.log("check photo object", objDataFromForm)
			var vCheck = validateDataOnform(objDataFromForm);
			if (vCheck) {
				if (glistPhoto && glistPhoto.length > 0) {
					glistPhoto.map(item => {
						if (item.photoCode == objDataFromForm.photoCode) {
							alert("photo existed")
						} else {
							console.log('check data post', objDataFromForm)
							callApiToPostData(objDataFromForm);
							onPageLoading();

						}
					})
				}

			}

		}
		//hàm thực hiện validate dữ liệu trên form
		function validateDataOnform(paramObjData) {
			if (!paramObjData.photoCode) {
				alert('Missing photo code')
				return false;
			}
			if (!paramObjData.photoName) {
				alert('Missing photo name')
				return false;
			}
			if (!paramObjData.photoLink) {
				alert('Missing photo link')
				return false;
			}
			if (!paramObjData.photoDescription) {
				alert('Missing photo description')
				return false;
			}
			return true;


		}
		//hàm thu thập dư liệu trên form
		function getDataOnForm(obj) {
			obj.photoCode = $('#input-photo-code').val();
			obj.photoName = $('#input-photo-name').val();
			obj.photoLink = $('#input-photo-link').val();
			obj.photoDescription = $('#input-photo-description').val();
			return obj
		}
		//hàm gọi api để tạo album mới
		function callApiToPostData(paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/photo/create/${galbumIdSelected}`,
				type: 'POST',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {

					console.log('check data post response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}
































		function callApiToGetAlbum() {
			$.ajax({
				async: false,
				url: "http://localhost:8080/albums/all",
				method: "GET",
				success: function (pObjRes) {
					gAlbumList = pObjRes
					loadDataToUserSelect(gAlbumList);
					console.log('check response user', pObjRes)

				},
				error: function (pXhrObj) {
					console.log(pXhrObj);
				}
			});
		}
		var gAlbumSelectElement = $("#album-select");
		//hàm load thông tin album vào ô select
		function loadDataToUserSelect(pAlbumList) {
			console.log("check select", gAlbumSelectElement)
			for (i = 0; i < pAlbumList.length; i++) {
				var bAlbumOption = $("<option/>");
				bAlbumOption.prop("value", pAlbumList[i].albumCode);
				bAlbumOption.prop("text", pAlbumList[i].albumName);
				gAlbumSelectElement.append(bAlbumOption);
			};
		}
		//hàm xử lí chọn album
		gAlbumSelectElement.on("change", function () {
			if (gAlbumList && gAlbumList.length > 0) {
				gAlbumList.map(item => {
					if (item.albumCode == $(this).val()) {
						galbumIdSelected = item.id
					}
				})
			}
			console.log('check album id', galbumIdSelected)
			onPageLoading();

		})
		function onPageLoading() {
			$.ajax({
				url: `http://localhost:8080/album/${galbumIdSelected}/photos`,
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log('check photo by id', res);
					glistPhoto = res
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			})
		}









	</script>
</body>

</html>